=== doc/CMakeLists.txt ===
if (BUILD_DOCUMENTATION)
  add_subdirectory(src)
endif ()
