=== libs/array/CMakeLists.txt ===
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    array.hpp
)

# Add a library target to the build system
boost_library_project(
  array
  #  SRCDIRS 
  TESTDIRS  test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "STL compliant container wrapper for arrays of constant size."
  MODULARIZED 
  AUTHORS  "Nicolai Josuttis"
  #  MAINTAINERS 
)
