=== tools/build/v2/debian/changelog ===
boost-build (2.0.m10-1) unstable; urgency=low

  * Initial Release.

 -- Vladimir Prus <ghost@cs.msu.su>  Wed, 14 Aug 2002 14:08:00 +0400
